# PassGAN
This is an implementation of the [PassGAN](https://arxiv.org/abs/1709.00440) paper.
It creates a neural network (using [IWGAN](https://github.com/igul222/improved_wgan_training)) to generate human-look alike passwords using the same parameters as in the paper by default but they can be adjusted as needed.

## Requirements
- Python 3.6+
- CUDA 8.0-9.0
- cuDNN 

## Set up

    # Create virtualenv
    python3 -m venv --system-site-packages env || virtualenv -p python3.6 --system-site-packages env
	# Install required libraries via pip
	env/bin/pip3 install -r requirements.txt


## Usage
### Training
	env/bin/python3 train.py \
	  -h, --help            show this help message and exit
	  --training-data
	                        Path to training data (UTF-8 encoded!)
      --dictionaries DICTIONARIES
                            Path to dictionary directory (UTF-8 encoded!)
	  --output		        Path to output directory
	  --save-intervall
	                        Save after n iterations (default: 1000)
	  --batch-size
	                        Batch size, which represents the number of passwords
	                        from the training set that propagate through the GAN
	                        at each step of the optimizer (default: 64)
	  --iterations
	                        Number of training iterations, which indicates how
	                        many times the GAN invokes its forward step and its
	                        back-propagation step. In each iteration, the GAN runs
	                        one generator iteration and one or more discriminator
	                        iterations (default: 199000)
	  --discriminator-iterations
	                        Number of discriminator iterations per generator
	                        iteration, which indicates how many iterations the
	                        generator performs in each GAN iteration (default: 10)
	  --layer               Number of residual layers for both the generator and
	                        the discriminator (default: 5)
	  --dimensionality
	                        Model dimensionality, which represents the number of
	                        dimensions (weights) for each convolutional layer
	                        (default: 128)
	  --gradient-penalty
	                        Gradient penalty coefficient, which specifies the
	                        penalty applied to the norm of the gradient of the
	                        discriminator with respect to its input (default: 10)
	  --output-length
	                        Output sequence length, which indicates the maximum
	                        length of the strings generated by the generator
	                        (default: 10)
	  --noise-size
	                        Size of the input noise vector (seed) which determines
	                        how many random bits are fed as input to G for the
	                        purpose of generating samples (default: 128)
	  --learning-rate
	                        (Adam optimizer's hyper parameters) Learning rate,
	                        i.e., how quickly the weights of the model are
	                        adjusted (default: 0.001)
	  --beta1               (Adam optimizer's hyper parameters) Coefficient Beta1,
	                        which specifies the decaying rate of the running
	                        average of the gradient (default: 0.5)
	  --beta2               (Adam optimizer's hyper parameters) Coefficient Beta2,
	                        which specifies the decaying rate of the running
	                        average of the square of the gradient (default: 0.9)
	  --gpu                 Index of the GPU to use (if existent). You can retrieve 
                            them via `nvidia-smi` (default: 0)
	  --v                   Enable verbose printing and logging (CRITICAL)
	  --vv                  Enable verbose printing and logging (CRITICAL, ERROR)
	  --vvv                 Enable verbose printing and logging (CRITICAL, ERROR,
                            WARNING)
	  --vvvv                Enable verbose printing and logging (CRITICAL, ERROR,
                            WARNING, INFO)
	  --vvvvv               Enable verbose printing and logging (CRITICAL, ERROR,
                            WARNING, INFO, DEBUG)

### Generating passwords
	env/bin/python3 generate.py
	  -h, --help            show this help message and exit
      --input               Path to output directory (from previous training eg.
                            /PassGAN/output)
      --model               Path to checkpoint file (eg.
                            /PassGAN/output/saved/model_199000.ckp)
      --output              Path to output directory where samples will be stored
                            (eg. /PassGAN/output/samples.txt)
      --amount              Amount of examples to generate (default: 1000000)
      --batch-size
                            Batch size, which represents the number of passwords
                            from the training set that propagate through the GAN
                            at each step of the optimizer (default: 64)
      --layer               Number of residual layers for both the generator and
                            the discriminator (default: 5)
      --dimensionality
                            Model dimensionality, which represents the number of
                            dimensions (weights) for each convolutional layer
                            (default: 128)
      --output-length 
                            Output sequence length, which indicates the maximum
                            length of the strings generated by the generator
                            (default: 10)
      --noise-size  
                            Size of the input noise vector (seed) which determines
                            how many random bits are fed as input to G for the
                            purpose of generating samples (default: 128)

                            
## Comparing versions
### How we tested
As stated in the paper we used [RockYou](http://downloads.skullsecurity.org/passwords/rockyou.txt.bz2) and [LinkedIn](https://hashes.org/leaks.php?id=68) datasets which we first filtered so it only contains passwords with a length less or equal than the default 10 and none which consist only of numbers:  
`cat training_data/rockyou.txt | grep -x '.\{1,10\}' | grep -v -E '^[0-9]+$' | uniq | shuf > training_data/rockyou_filtered.txt`  
We then split it into sets of size 80% and 20% with:  
`cat training_data/rockyou_filtered.txt | head -n $(echo "0.8 * $(cat training_data/rockyou_filtered.txt | wc -l) / 1" | bc) > training_data/rockyou_training.txt`  
`cat training_data/rockyou_filtered.txt | tail -n $(echo "0.2 * $(cat training_data/rockyou_filtered.txt | wc -l) / 1" | bc) > training_data/rockyou_testing.txt`  
And run three instances:  
* with dictionary (dictionaries/english_words.txt)  
* without dictionary  
* an instance from [here](https://github.com/brannondorsey/PassGAN) for comparison  

To compare each version we used the same approach as in the paper and took the time each model needed to train, the quality when checking against the `rockyou_testing.txt` and `linkedIn.txt` sets. The quality is specified as how many passwords PassGAN was able to find in the test sets when generating 10^8 passwords for each saved checkpoint.


## Further Doing
### Using multiple GPUs
Good Example for a GAN with Multi-GPU support: https://github.com/timsainb/Tensorflow-MultiGPU-VAE-GAN  
Tensorflow's Multi-GPU tutorial: https://www.tensorflow.org/tutorials/deep_cnn#training_a_model_using_multiple_gpu_cards  

Problem with our implementation is the missing structure, as it is described in VAE-GAN or the Multi-GPU tutorial of tensorflow. I. e. in these examples, the code is divided in steps like chunk distribution, gradient computation, gradient averaging, backpropagation and so on. In our model, these steps are only partially visible in the train.py, e. g. the gradient computation.
Another important part of a Multi-GPU setup is the correct distribution of the variables across the GPUs and the fact that they have to be shared with the CPU. This is mandatory, since every GPU should hold a full "model replica", i. e. each GPU holds the entire GAN. In one round of the aforementioned steps, each GPU gets a different chunk of the training set and then computes the gradients for this chunk. After that the CPU grabs the gradients of all GPUs, averages them and propagates the averaged gradients back onto each GPU. The problem in our implementation is that the work concerning the variable scopes is done in the abstraction layer provided by the "tflib", i. e. the same layer as the operations on the input. According to the tutorials, this is supposed to be one layer above, where the GAN itself is defined.
In fact, this leads to the conclusion, that this model was never supposed to be run in a Multi-GPU setting. This means a big part of the code needs to be rewritten, or even build up from scratch.

### Optimize data inputs
Tensorflow Guide for Data Input: https://www.tensorflow.org/api_guides/python/reading_data  

According to the mentioned guide, the data reading method used in our model (Feeding) is the "least efficient way to feed data into a Tensorflow program and should only be used for small experiments and debugging". There is in fact a specific API (tf.data), which yields more efficient methods for this task.

### Fix data set size problems
One of the most important things we noticed is that there is an upper bound for the training dataset, which is actually used. 
This can be computed by   

`Batch Size * Critic Iterations * Iterations = Max. Size of Used Data`  

For the settings used in the PassGAN paper:
 
`64 * 10 * 199,000 =  127,360,000`

It is therefore recommended to adjust the size of the dataset. Increasing the iterations according to the used dataset is also a possibility, but then overfitting, as explained in the PassGAN paper, might become a problem.

### Pattern matching
As simply checking characters only as in the original paper it might be more efficient to use dictionaries and permutations of words in them as data sets. This is kinda supported in this version already with the dictionary flag but it is not that efficient yet. Also it does not use permutations of words. Maybe there is a better way to create a dictionary set for each password list first before running the learning process.
